// poker.h : main header file for the POKER application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "..\cards.h"

#include "resource.h"		// main symbols
                            
// What a player can do:
#define		NOTHING			0
#define		BET				1
#define		CALL			2
#define 	FOLD			3  	
#define		RAISE			4
#define		CHECK			5

// The current state of the game:
#define		DEAL			0
#define		FIRST_ROUND		1
#define		DRAW_SELECT		2
#define		DRAW_DISCARD	3
#define		DRAW_DEAL		4
#define		SECOND_ROUND	5
#define		SHOWDOWN		6
#define		WAIT			7
                             
// State of the cards in a player's hand.

#define		CARD_OK			0
#define 	CARD_DISCARD	6
#define		CARD_FOLD		7
#define 	CARD_INVERT		2

// Hands that players (can) have.

#define		ROYAL_FLUSH			999
#define		STRAIGHT_FLUSH		900
#define		FOUR_OF_KIND		850
#define		FULL_HOUSE			800
#define		FLUSH				750
#define		STRAIGHT			700
#define		THREE_OF_KIND		650
#define		TWO_PAIR			600
#define		ONE_PAIR			550
#define		POSSIBLE_STRAIGHT	450
#define		POSSIBLE_FLUSH		350
#define		GOT_SQUAT			250
                             
// Misc defines...

#define 	LEFT			0
#define 	DEALER			1
#define 	RIGHT			2
#define 	ME				3
#define 	NUMBER_PLAYERS	4

/////////////////////////////////////////////////////////////////////////////
// CPokerApp:
// See poker.cpp for the implementation of this class
//

class CPokerApp : public CWinApp
{
public:
	CPokerApp();

// Overrides
	virtual BOOL InitInstance();

// Implementation

	//{{AFX_MSG(CPokerApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
