// pokerdoc.cpp : implementation of the CPokerDoc class
//

#include "stdafx.h"
#include "poker.h"

#include "pokerdoc.h"
#include "cardback.h"

#include <time.h>

int CompareInt(const void *arg1, const void *arg2 );

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPokerDoc

IMPLEMENT_DYNCREATE(CPokerDoc, CDocument)

BEGIN_MESSAGE_MAP(CPokerDoc, CDocument)
	//{{AFX_MSG_MAP(CPokerDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPokerDoc construction/destruction

CPokerDoc::CPokerDoc()
{
	// TODO: add one-time construction code here
int		i;

//	CPokerDoc* pDoc = GetDocument();
	
	CDTInit(&nWidth, &nHeight);
	TRACE("CDTInit NEW: returned %d, %d \n", nWidth, nHeight);

/*	Seed the random-number generator with current time so that
 *		the numbers will be different every time we run.
 */
	srand((unsigned)time(NULL));

/* 	the back of the cards should be saved in the .ini file,
 *  	rather than being hardcoded...
 */

	nCurrentBack = BK_CARD_HAND; 
	nBackAnimate = 0;		// State of the animation of the cards.
	nCurrentCard = 0;		// Which card is the current one.
	nCurrentPlayer = 2; 	// The current player is ME! (for the first hand)
	nOldCurrentPlayer = 3; 	// The current player was ME! (for the first hand)
	nAnimateCard = 0;		// Which card is being animated
	nAnimationCounter = 20; // Ten seconds to next animation...
	nGameState = DEAL;		// Tell the game to deal the cards.

//  bCan... are really set by the timer routine.	
	bCanCall = TRUE;
	bCanBet = TRUE;		
	bCanFold = TRUE;		
	bCanRaise = TRUE;		
	bCanCheck = TRUE;		

	for (i = 0; i < NUMBER_PLAYERS; i++)
	{// Then the user can reset this with the options dialog!
		nPlaying[i] = TRUE;
		nPlayerAction[i] = NOTHING;
		bFace[i] = FALSE;			// Show backs for other players.
	}

/* 	Locate the cards in the window. Enhancement might include
 *		repositioning when the window is resized...
 */

	CardLocation[0][0].x =  10; CardLocation[0][0].y =  48;
	CardLocation[0][1].x =  10; CardLocation[0][1].y =  96;
	CardLocation[0][2].x =  10; CardLocation[0][2].y = 144;
	CardLocation[0][3].x =  10; CardLocation[0][3].y = 192;
	CardLocation[0][4].x =  10; CardLocation[0][4].y = 240;

	CardLocation[1][0].x = 101; CardLocation[1][0].y =  24;
	CardLocation[1][1].x = 191; CardLocation[1][1].y =  24;
	CardLocation[1][2].x = 282; CardLocation[1][2].y =  24;
	CardLocation[1][3].x = 372; CardLocation[1][3].y =  24;
	CardLocation[1][4].x = 462; CardLocation[1][4].y =  24;

	CardLocation[2][0].x = 553; CardLocation[2][0].y =  48;
	CardLocation[2][1].x = 553; CardLocation[2][1].y =  96;
	CardLocation[2][2].x = 553; CardLocation[2][2].y = 144;
	CardLocation[2][3].x = 553; CardLocation[2][3].y = 192;
	CardLocation[2][4].x = 553; CardLocation[2][4].y = 240;

	CardLocation[3][0].x = 101; CardLocation[3][0].y = 270;
	CardLocation[3][1].x = 191; CardLocation[3][1].y = 270;
	CardLocation[3][2].x = 282; CardLocation[3][2].y = 270;
	CardLocation[3][3].x = 372; CardLocation[3][3].y = 270;
	CardLocation[3][4].x = 462; CardLocation[3][4].y = 270;

/*	Then do the initial deal of the cards. Deal is then called whenever the current hand 
 *		ends.
 */           
 
	NewGame();    
}

CPokerDoc::~CPokerDoc()
{
}

void CPokerDoc::NewGame()
{
int		i;
	for (i = 0; i < NUMBER_PLAYERS; i++)
	{// That's 100 $5 chips per player.
		nChips[i] = 100;
	}

	nPot = 0;
	Deal(); // To initialize the deck for the first hand of the game
}

CPokerDoc::Deal()
{
int		nCard;
int		nHits[52];   
int		i;
int		j;

// Set up this hand...

	nOldCurrentPlayer = nCurrentPlayer;
	nCurrentPlayer = nOldCurrentPlayer; 
	if (++nCurrentPlayer > 3)
		nCurrentPlayer = 0;

// First, shuffle the deck of cards...
	for (i = 0; i < 52; i++)
		nHits[i] = TRUE;
		
	for (j = 0, i = 0; i < 52; i++)
	{
		do 
		{
			nCard = rand() % 52;
		} while (!nHits[nCard]);
		
		nDeck[j++] = nCard;
		nHits[nCard] = FALSE;
	}
	
	for (nCurrentCard = 0, i = 0; i < 5; i++)
	{// Next, deal the cards out. 
		for (j = 0; j < NUMBER_PLAYERS; j++)
		{
			nCardState[j][i] = CARD_OK;
			nHand[j][i] = nDeck[nCurrentCard++];
		}
	}
	
	for (i = 0; i < NUMBER_PLAYERS; i++)
	{// Sort the hands...
		qsort(nHand[i], 5, sizeof(int), CompareInt);
	}

	TRACE("Deal setting nOwed to 0\n");
	for (i = 0; i < NUMBER_PLAYERS; i++)
	{// Finally, fix the pot, getting the Ante from each playing player:
		nOwed[i] = 0;
		if (nPlaying[i])
		{
			bFace[i] = FALSE;			// Show backs for other players.
			nChips[i] -= 1;				// Put in the Ante
			nPot += 1;
			nPlayerAction[i] = NOTHING; // Ready to start!
			nPlayerBet[i] = 0;
		}
	}
	
	nGameState = FIRST_ROUND;

//To get the first view in the list of views:

	POSITION pos = GetFirstViewPosition();
	CView* pFirstView = GetNextView( pos );

	TRACE("Deal clearing the window...\n");

    pFirstView->InvalidateRect(NULL, TRUE);
	
	return(TRUE);
}

int CompareInt(const void *arg1, const void *arg2)
{// Sort in reverse order, gives king to left...
	if (*(int *)arg1 < *(int *)arg2)
		return ( 1);
		
	if (*(int *)arg1 > *(int *)arg2)
		return (-1);
	           
    return(0);
}           

void CPokerDoc::Bet(int	nPlayer, int nChipsBet)
{
	TRACE("Player %d action was BET %d chips\n", nPlayer, nChipsBet);
	nChips[nPlayer] -= nChipsBet;
	nPot += nChipsBet;
	nPlayerAction[nPlayer] = BET;
	for (int i = 0; i < NUMBER_PLAYERS; i++)
	{// Get the other player's chips.
		if (i != nPlayer && nPlayerAction[i] != FOLD)
		{
			nOwed[i] += nChipsBet;
			TRACE("Player %d now owes %d chips\n", i, nOwed[i]);
		}
	}
}

void CPokerDoc::Call(int nPlayer)
{
	nChips[nPlayer] -= nOwed[nPlayer];
	nPot += nOwed[nPlayer];
	TRACE("Player %d action was CALL putting %d chips in the pot\n", nPlayer, nOwed[nPlayer]);
	nOwed[nPlayer] = 0;
	nPlayerAction[nPlayer] = CALL;
}

void CPokerDoc::Fold(int nPlayer)
{
	nPlayerAction[nPlayer] = FOLD;
	nOwed[nPlayer] = 0;
	TRACE("Player %d action was FOLD\n", nPlayer);
}

void CPokerDoc::Raise(int nPlayer, int nChipsBet)
{
	nChips[nPlayer] -= (nChipsBet + nOwed[nPlayer]);
	nPot += (nChipsBet + nOwed[nPlayer]);
	nOwed[nPlayer] = 0;
	nPlayerAction[nPlayer] = RAISE;
	for (int i = 0; i < NUMBER_PLAYERS; i++)
	{// Get the other player's chips.
		if (i != nPlayer && nPlayerAction[i] != FOLD)
			nOwed[i] += nChipsBet;
	}
	TRACE("Player %d action was RAISE %d chips\n", nPlayer, nChipsBet);
}

void CPokerDoc::Check(int nPlayer)
{
	nPlayerAction[nPlayer] = CHECK;
	TRACE("Player %d action was CHECK\n", nPlayer);
}

void CPokerDoc::NextPlayer()
{
	if (++nCurrentPlayer >= NUMBER_PLAYERS)
		nCurrentPlayer = 0;
		
	if (nPlayerAction[nCurrentPlayer] == FOLD)
		if (++nCurrentPlayer >= NUMBER_PLAYERS)
			nCurrentPlayer = 0;
			
	if (nPlayerAction[nCurrentPlayer] == FOLD)
		if (++nCurrentPlayer >= NUMBER_PLAYERS)
			nCurrentPlayer = 0;
			
	if (nPlayerAction[nCurrentPlayer] == FOLD)
		if (++nCurrentPlayer >= NUMBER_PLAYERS)
			nCurrentPlayer = 0;
}

void CPokerDoc::UpdateGameState()
{// Note: return in middle of function -
int 	i;

	for (i = 0; nGameState != DEAL && i < NUMBER_PLAYERS; i++)
	{
		if (nPlayerAction[i] == NOTHING || nOwed[i] != 0)
		{//	We've a player who's not had their turn, or who still owes to the pot.
// Was: 		Debugging lines are commented out:
// Was:			if (nPlayerAction[i] == NOTHING)
// Was:				TRACE("Can't update nGameState, nPlayerAction[%d] == NOTHING\n", i);
// Was:			if (nOwed[i] != 0)
// Was:				TRACE("Can't update nGameState, nOwed[%d] > 0\n", i);
				
			return;		
		}
	}

	for (i = 0; i < NUMBER_PLAYERS; i++)
	{
		if (nPlayerAction[i] != FOLD)
		{// Once you've folded, you're out for the hand...
			nPlayerAction[i] = NOTHING;
		}
	}
	
	++nGameState;

	switch(nGameState)
	{
		case DEAL:
			TRACE("Updating the game state to DEAL\n");
			break;
		case FIRST_ROUND:
			TRACE("Updating the game state to FIRST_ROUND\n");
			break;
		case DRAW_SELECT:
			TRACE("Updating the game state to DRAW_SELECT\n");
			break;
		case DRAW_DISCARD:
			TRACE("Updating the game state to DRAW_DISCARD\n");
			break;
		case DRAW_DEAL:
			TRACE("Updating the game state to DRAW_DEAL\n");
			break;
		case SECOND_ROUND:
			TRACE("Updating the game state to SECOND_ROUND\n");
			break;
		case SHOWDOWN:
			TRACE("Updating the game state to SHOWDOWN\n");
			break;
		case WAIT:
			TRACE("Updating the game state to WAIT for new hand\n");
			break;
		default:
			TRACE("Updating the game state to *UNKNOWN* STATE!!!!\n");
			break;
	}
}

int		CPokerDoc::DealDraw(int nPlayer)
{
int		i;
int		bTookCards = FALSE;

	TRACE("DealDraw called, may clear the window...\n");

	for (i = 0; i < 5; i++)
	{
		if (nCardState[nPlayer][i] == CARD_INVERT)
		{// card selected for replacement by the player
			bTookCards = TRUE;
			nCardState[nPlayer][i] = CARD_OK;
			nHand[nPlayer][i] = nDeck[nCurrentCard++];
		}
	}			

	qsort(nHand[nPlayer], 5, sizeof(int), CompareInt);
    
    if (bTookCards)
    {
    	return(TRUE);
    }
    else
    {
    	return(FALSE);
    }
}

BOOL CPokerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CPokerDoc serialization

void CPokerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


/////////////////////////////////////////////////////////////////////////////
// CPokerDoc diagnostics

#ifdef _DEBUG
void CPokerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPokerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPokerDoc commands

//	The following routine (EvaluateFirst) can be used as a foundation to create
//  the necessary logic to evaluate the hand and develop a play logic (something that
//	this game is currently missing -- but then I want you to develop player strategy
//	and play techniques. Of course, you can let me see what you've done with this 
//	program!

int		CPokerDoc::EvaluateFirst(int nPlayer)
{// Evaluate the player's hand, return a relative value. 
//	Rember: cards are sorted by value/suite.

#define	CARD_SUIT(n)	(n % 4)
#define	CARD_VALUE(n)	(n / 4)

int		i;
int		nCard;
int		nSuit;
int		nReturn;
int		nSuitCount[4];

// 	Look for a royal flush (rare!)
	for (i = 0; i < 4; i++)
	{
		if (nHand[nPlayer][0] == (i * 13) + 12 &&
			nHand[nPlayer][1] == (i * 13) + 11 &&
			nHand[nPlayer][2] == (i * 13) + 10 &&
			nHand[nPlayer][3] == (i * 13) + 9 &&
			nHand[nPlayer][4] == (i * 13) + 0)
		{// WOW, a real winner!
			return(ROYAL_FLUSH);
		}
	}
	
//	Now look for a STRAIGHT_FLUSH:
	nCard = nHand[nPlayer][4];
	
	if (nHand[nPlayer][3] == nCard + 1 &&
		nHand[nPlayer][2] == nCard + 2 &&
		nHand[nPlayer][1] == nCard + 3 &&
		nHand[nPlayer][0] == nCard + 4)
	{// A straight flush, Still realy good!
		return(STRAIGHT_FLUSH);
	}

//	Now look for FOUR_OF_KIND
	for (i = 0; i < 13; i++)
	{                               
		nCard = CARD_VALUE(nHand[nPlayer][0]);
		if (nCard == CARD_VALUE(nHand[nPlayer][3]) &&
			nCard == CARD_VALUE(nHand[nPlayer][2]) &&
			nCard == CARD_VALUE(nHand[nPlayer][1]))
		{
			return(FOUR_OF_KIND);
		}
		
		nCard = CARD_VALUE(nHand[nPlayer][1]);
		if (nCard == CARD_VALUE(nHand[nPlayer][4]) &&
			nCard == CARD_VALUE(nHand[nPlayer][3]) &&
			nCard == CARD_VALUE(nHand[nPlayer][2]))
		{
			return(FOUR_OF_KIND);
		}
	} 
	
//	Now look for three of a kind, then for a full house
	nReturn = GOT_SQUAT;
	nCard = CARD_VALUE(nHand[nPlayer][0]);
	if (nCard == CARD_VALUE(nHand[nPlayer][2]) &&
		nCard == CARD_VALUE(nHand[nPlayer][1]))
	{// Check to see if the remaing cards are same:
		if (CARD_VALUE(nHand[nPlayer][3]) ==
			CARD_VALUE(nHand[nPlayer][4]))
		{
			nReturn = FULL_HOUSE;
		}
		else
		{
			nReturn = THREE_OF_KIND;
		}
	}
	nCard = CARD_VALUE(nHand[nPlayer][2]);
	if (nCard == CARD_VALUE(nHand[nPlayer][3]) &&
		nCard == CARD_VALUE(nHand[nPlayer][4]))
	{
		if (CARD_VALUE(nHand[nPlayer][0]) ==
			CARD_VALUE(nHand[nPlayer][1]))
		{
			nReturn = FULL_HOUSE;
		}
		else
		{
			nReturn = THREE_OF_KIND;
		}
	}

// Check the remaining possible three of a kind:
	nCard = CARD_VALUE(nHand[nPlayer][1]);
	if (nCard == CARD_VALUE(nHand[nPlayer][2]) &&
		nCard == CARD_VALUE(nHand[nPlayer][3]))
	{
		nReturn = THREE_OF_KIND;
	}

//	Check for a flush:
	nSuit = CARD_SUIT(nHand[nPlayer][0]);
	if(nSuit == CARD_SUIT(nHand[nPlayer][1]) &&
		nSuit == CARD_SUIT(nHand[nPlayer][2]) &&
		nSuit == CARD_SUIT(nHand[nPlayer][3]) &&
		nSuit == CARD_SUIT(nHand[nPlayer][4]))
	{
		return(FLUSH);
	}
	
//	Check for a straight:
	nCard = CARD_VALUE(nHand[nPlayer][0]);
	if((nCard - 1) == CARD_VALUE(nHand[nPlayer][1]) &&
		(nCard - 2) == CARD_VALUE(nHand[nPlayer][2]) &&
		(nCard - 3) == CARD_VALUE(nHand[nPlayer][3]) &&
		(nCard - 4) == CARD_VALUE(nHand[nPlayer][4]))
	{
		return(STRAIGHT);
	}

// Check for TWO pair:
	nReturn = GOT_SQUAT;
	if (CARD_VALUE(nHand[nPlayer][0]) == CARD_VALUE(nHand[nPlayer][1]) &&
		(CARD_VALUE(nHand[nPlayer][2]) == CARD_VALUE(nHand[nPlayer][3]) ||
		CARD_VALUE(nHand[nPlayer][3]) == CARD_VALUE(nHand[nPlayer][4])))
	{
		return(TWO_PAIR);
	}                    
	if (CARD_VALUE(nHand[nPlayer][1]) == CARD_VALUE(nHand[nPlayer][2]) &&
		CARD_VALUE(nHand[nPlayer][3]) == CARD_VALUE(nHand[nPlayer][4]))
	{
		return(TWO_PAIR);
	}                    

// Check for ONE pair
	if (CARD_VALUE(nHand[nPlayer][0]) == CARD_VALUE(nHand[nPlayer][1]) ||
		CARD_VALUE(nHand[nPlayer][1]) == CARD_VALUE(nHand[nPlayer][2]) ||
		CARD_VALUE(nHand[nPlayer][2]) == CARD_VALUE(nHand[nPlayer][3]) ||
		CARD_VALUE(nHand[nPlayer][3]) == CARD_VALUE(nHand[nPlayer][4]))
	{
		nReturn = ONE_PAIR;
	}
	
//	Got squat, but there may be possible flushes or straights...
//	Check for possible STRAIGHT: (four in a row, 2 - Q)

	nCard = CARD_VALUE(nHand[nPlayer][0]);
	if((nCard - 1) == CARD_VALUE(nHand[nPlayer][1]) &&
		(nCard - 2) == CARD_VALUE(nHand[nPlayer][2]) &&
		(nCard - 3) == CARD_VALUE(nHand[nPlayer][3]))
	{
		return(POSSIBLE_STRAIGHT);
	}
	
	nCard = CARD_VALUE(nHand[nPlayer][1]);
	if((nCard - 1) == CARD_VALUE(nHand[nPlayer][2]) &&
		(nCard - 2) == CARD_VALUE(nHand[nPlayer][3]) &&
		(nCard - 3) == CARD_VALUE(nHand[nPlayer][4]))
	{
		return(POSSIBLE_STRAIGHT);
	}
	
//	Check for possible flush: (Four of the same suit)

    for (i = 0; i < 4; i++)
		nSuitCount[i] = 0;	
	
    for (i = 0; i < 5; i++)
		++nSuitCount[CARD_SUIT(nHand[nPlayer][i])];
		
	for (i = 0; i < 4; i++)
		if (nSuitCount[i] > 3)
			return(POSSIBLE_FLUSH); 		

//	Didn't get nuttin! Dis hand's a looser!
    
	return(GOT_SQUAT);    
}
