// appinfo.h
//
// class interface to the application class
// (which is the internally used description of
// an application)    
//
// each button has a CApplicationList attached to it
//
// update: 1.00 08-Aug-93 tw

#ifndef _INC_APPINFO_H
#define _INC_APPINFO_H

class CApplication : public CObject
{  
private:
   CString  m_strAppPath,
            m_strAppTitle,
            m_strAppArgs,
            m_strAppInitialDir;
            
   // ICON ???
   int     m_nRunState;
               
public:  
   CApplication();  
   CApplication( const CApplication& rApp );
   CApplication( const char * pszPath,
                 const char * pszTitle = 0,
                 const char * pszArgs = 0,
                 const char * pszInitialDir = 0,
                 int nRunState = 2 );
   void Description( const char * pszPath,
                const char * pszTitle,
                const char * pszArgs = 0,
                const char * pszInitialDir = 0,
                int nRunState = 2 );
   
   
               
   void Run() const;               
   // void DumpToProfile() const;
                
   // Query some fields                  
   //const char * Path() const;
   const char * Title() const;
   const char * Path() const;
   const char * Args() const;
   const char * InitialDir() const;
   int RunState() const;
   // HICON Icon() const();
   
   BOOL ReadProfile( const char * pszTag, int nProfileIndex );
   void DumpProfile( const char * pszTag, int nProfileIndex );
   
};

class CApplicationList : public CObList
{                    
private:
   UINT     m_nIcon;                // icon # from specified file
   CString  m_strIconFile;          // take icon from this file
   //HICON    m_hIcon;                // icon to use

public:
   CApplicationList();
   ~CApplicationList();
   void Add( CApplicationList* pNewList );
   void Add( const char * pszPath );
//   POSITION AddTail( CApplication* newElement );
   
   void RemoveAll();
   
   void ReadProfile( int nProfileIndex );
   void DumpProfile( int nProfileIndex );
            
   // Set icon            
   void Icon( const char * pszIconFile, UINT nIcon );
   
   HICON Icon() const;   // retrieve Icon to use
   const CString& IconFile() const;
   UINT IconID() const;
   
   CApplication*& GetNext( POSITION& rPos );
   CApplication* GetNext( POSITION& rPos ) const;
   CApplication*& GetAt( POSITION pos );
   CApplication* GetAt( POSITION pos ) const;
};

#endif //_INC_APPINFO_H


