// mainwnd.h
//
// class interface to the main window class
//
// update: 1.00 27-Jul-93 tw

#ifndef _INC_MAINWND_H
#define _INC_MAINWND_H

#define new DEBUG_NEW 

#include "iconbtn.h"
#include "app.h"
                                
class CMainWnd : public CFrameWnd
{     
private:  
   CRect * m_pRectCaption;    // sizeof caption
     
   // the icon buttons
   CIconButton m_arrIconButtons[ nIconButtons ];  
   
   // the "edit" buttons
   CButton m_arrEditButtons[ nIconButtons ];
          
   // 3 toolbars
   CToolBar m_wndTileBar,
            m_wndWorkspaceBar,
            m_wndOptionsBar;
   
   // the toolbars rects         
   CRect    m_rectTileBar,
            m_rectWorkspaceBar,
            m_rectOptionsBar;            
            
   CRect    m_rectWnd;            
   
   // helpers 
   void CreateToolBar(  CToolBar * pBar, 
                        UINT nIdResource, 
                        const UINT * pArrBtns, 
                        CRect * pRect );
            
   void OnLaunch( int nGrp );
   void OnEdit( int nGrp );
               
protected:
   enum 
   {  
      // the toolbars sizes
      cxImageToolBar = 10,   
      cyImageToolBar = 10,
      cxBtnToolBar = 16,
      cyBtnToolBar = 16,
      
      cxFrameToolBar = 6,
      cyFrameToolBar = 2,
      
   };            
      
   // number of buttons on toolbar      
   int m_nToolBarButtons;

public:
   CMainWnd(); 
   ~CMainWnd();
   
   // the following is called by childs on drop events
   void DroppedFiles( HDROP hDrop, UINT nID );
   
protected:                                               
   afx_msg UINT OnNcHitTest( CPoint pnt );
   afx_msg void OnPaint();
   afx_msg BOOL OnEraseBkgnd( CDC* pDC );
   
   afx_msg void OnActivateApp( BOOL bActive, HTASK hTask );

   afx_msg int OnCreate( LPCREATESTRUCT lpCreateStruct );
   afx_msg void OnSysCommand( UINT nID, LPARAM lParam );
                         
   // command handler for launch buttons
   // (will call OnLaunchGroup() or OnEditGroup() )
   void OnLaunchGrp1();
   void OnLaunchGrp2();
   void OnLaunchGrp3();
   void OnLaunchGrp4();
   void OnLaunchGrp5();
   void OnLaunchGrp6();
   void OnLaunchGrp7();
   void OnLaunchGrp8();
   void OnEditGrp1();
   void OnEditGrp2();
   void OnEditGrp3();
   void OnEditGrp4();
   void OnEditGrp5();
   void OnEditGrp6();
   void OnEditGrp7();
   void OnEditGrp8();
                            
   DECLARE_MESSAGE_MAP()   

};
                    
// Toolbar buttons
const UINT IDB_TILE1 = 101;
const UINT IDB_TILE2 = 102;
const UINT IDB_TILE3 = 103;
const UINT IDB_TILE4 = 104;

const UINT IDB_WSP1 = 105;
const UINT IDB_WSP2 = 106;
const UINT IDB_WSP3 = 107;
const UINT IDB_WSP4 = 108;

const UINT IDB_OPTS1 = 109;
const UINT IDB_OPTS2 = 110;
const UINT IDB_OPTS3 = 111;
const UINT IDB_OPTS4 = 112;
                    
#endif // _INC_MAINWND_H


