// wndlst.cpp
//
// behaviour of the main window class list
// update: 1.00 08-08-93 tw

#include <afxwin.h>
#include <afxext.h> 
#include <ctl3d.h>

#include "wndlst.h"

CRawHWnd::CRawHWnd( HWND hWnd )
{
   m_hWnd = hWnd;   
}  

// get all windows to be tiled. this might not catch
// _every_ window, but what the heck. anyone is free to
// add all those to the list he wants in there.
BOOL 
CRawHWnd::IsTileWindow() const
{
   CWnd * pWnd = CWnd::FromHandle( m_hWnd );
   
   if ( ! pWnd->IsIconic() &&
          pWnd->IsWindowVisible() &&
          ( pWnd->GetStyle() & WS_OVERLAPPEDWINDOW ) &&
          ( ! ( pWnd->GetStyle() & WS_POPUP )) )
   {          
      return TRUE;
   }      
   else
   {
      return FALSE;      
   }      
}

CMainWndList::CMainWndList()
{
   // get a list of the current main windows
   ::EnumWindows( EnumWindowProc, (LPARAM)this );
}                                     
  
CMainWndList::~CMainWndList()
{
   // remove the CRawHWnds
   for ( POSITION pos=GetHeadPosition(); pos!=NULL; )
   {
      delete GetNext( pos );
   }
}
     
/* static */
BOOL CALLBACK __export 
CMainWndList::EnumWindowProc( HWND hWnd, LPARAM lParam )
{
   CMainWndList *pLst = (CMainWndList*)lParam;
   pLst->AddTail( new CRawHWnd( hWnd ) );
   
   TRACE("Added a new window to the window list: %4.4X\n", hWnd );
   
   return TRUE;
}

CRawHWnd*& 
CMainWndList::GetNext( POSITION& rPos )
{
   return (CRawHWnd*&)CObList::GetNext( rPos );
}

CRawHWnd* 
CMainWndList::GetNext( POSITION& rPos ) const
{
   return (CRawHWnd*)CObList::GetNext( rPos );
}

CRawHWnd*& 
CMainWndList::GetAt( POSITION pos )
{  
   return (CRawHWnd*&)CObList::GetAt( pos );
}

CRawHWnd* 
CMainWndList::GetAt( POSITION pos ) const
{
   return (CRawHWnd*)CObList::GetAt( pos );
}

int
CMainWndList::GetTileCount()
{
   int nTile = 0;
   
   for ( POSITION pos=GetHeadPosition(); pos!=NULL; )
   {
      CRawHWnd * pWnd = GetNext( pos );
      if ( pWnd->IsTileWindow() )
         nTile++;
   }
         
   return nTile;         
}
